Summary:        Interactive packet manipulation tool and network scanner
Name:           scapy
Version:        2.5.0
Release:        7%{?dist}
License:        GPLv2
URL:            http://www.secdev.org/projects/scapy/
Source0:        https://github.com/secdev/scapy/archive/v%{version}.tar.gz#/%{name}-%{version}.tar.gz

BuildRequires:  make
BuildRequires:  sed python3-devel python3-setuptools
Recommends:     tcpdump wireshark-cli

BuildArch:      noarch


%description
Scapy is a powerful interactive packet manipulation program built on top
of the Python interpreter. It can be used to forge or decode packets of
a wide number of protocols, send them over the wire, capture them, match
requests and replies, and much more.


%package -n python3-%{name}
Summary:        Interactive packet manipulation tool and network scanner
Provides:       %{name} = %{version}-%{release}
Recommends:     PyX ipython3 python3-matplotlib

%description -n python3-%{name}
Scapy is a powerful interactive packet manipulation program built on top
of the Python interpreter. It can be used to forge or decode packets of
a wide number of protocols, send them over the wire, capture them, match
requests and replies, and much more.


%package doc
Summary:        Interactive packet manipulation tool and network scanner
BuildRequires:  python3-sphinx python3-sphinx_rtd_theme

%description doc
Scapy is a powerful interactive packet manipulation program built on top
of the Python interpreter. It can be used to forge or decode packets of
a wide number of protocols, send them over the wire, capture them, match
requests and replies, and much more.


%prep
%autosetup -p 1 -n %{name}-%{version}

SHEBANGS=$(find ./scapy -name '*.py' -print | xargs grep -l -e '^#!.*env python')
for FILE in $SHEBANGS ; do
    sed -i.orig -e 1d "${FILE}"
    touch -r "${FILE}.orig" "${FILE}"
    rm "${FILE}.orig"
done


%build
%py3_build

# The following commands refer to tox.ini to remove the dependency on tox
sphinx-apidoc -f --no-toc -d 1 --separate --module-first --templatedir=_templates --output-dir api scapy scapy/modules/ scapy/libs/ scapy/tools/ scapy/arch/ scapy/contrib/cansocket* scapy/contrib/scada/* scapy/all.py scapy/layers/all.py
# Set SCAPY_APITREE=0 to avoid generating an API tree that requires "tox"
make -C doc/scapy html BUILDDIR=_build_doc SCAPY_APITREE=0 SPHINXBUILD=sphinx-build-%python3_version
rm -f doc/scapy/_build_doc/html/.buildinfo
rm -f doc/scapy/_build_doc/html/_static/_dummy


%install
install -dp -m0755 %{buildroot}%{_mandir}/man1
install -Dp -m0644 doc/scapy.1* %{buildroot}%{_mandir}/man1/

%py3_install
rm -f %{buildroot}%{python3_sitelib}/*egg-info/requires.txt
mv -f %{buildroot}%{_bindir}/scapy %{buildroot}%{_bindir}/scapy3
ln -s %{_bindir}/scapy3 %{buildroot}%{_bindir}/scapy


# check
# cd test/
# ./run_tests


%files -n python3-%{name}
%license LICENSE
%doc %{_mandir}/man1/scapy.1*
%{_bindir}/scapy
%{_bindir}/scapy3
%{python3_sitelib}/scapy/
%{python3_sitelib}/scapy-*.egg-info
%exclude %{python3_sitelib}/test/

%files doc
%doc doc/scapy/_build_doc/html


%changelog
* Fri Aug 30 2024 Miaojun Dong <zoedong@tencent.com> - 2.5.0-7
- Drop BuildRequires for tox

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.5.0-6
- Rebuilt for loongarch release

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.5.0-5
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.5.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.5.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.5.0-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 08 2023 Miaojun Dong <zoedong@tencent.com> - 2.5.0-1
- initial build
